#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Mar 25 12:07:18 2021

@author: Evi
"""


#!/usr/bin/env python3

# standard library modules
import sys, errno, re, json, ssl
from urllib import request
from urllib.error import HTTPError
from time import sleep
from openpyxl import load_workbook
workbook = load_workbook(filename="uniprots_mcsa.xlsx")
sheet = workbook.active
UniprotID = []

for col in sheet['A']:
    UniprotID.append(col.value)
    
Uniprot = UniprotID[1:2592]

sys.stdout = open('mcsa2.tsv', 'w')

for x in range(1):
    print(x, file=sys.stderr, end=" ")
    BASE_URL = "https://www.ebi.ac.uk/thornton-srv/m-csa/api/entries/?format=json&entries.proteins.sequences.uniprot_ids="+Uniprot[x]
    
    def parse_items(items):
      if type(items)==list:
        return ",".join(items)
      return ""
    def parse_member_databases(dbs):
      if type(dbs)==dict:
        return ";".join([f"{db}:{','.join(dbs[db])}" for db in dbs.keys()])
      return ""
    def parse_go_terms(gos):
      if type(gos)==list:
        return ",".join([go["identifier"] for go in gos])
      return ""
    def parse_locations(locations):
      if type(locations)==list:
        return ",".join(
          [",".join([f"{fragment['start']}..{fragment['end']}" 
                    for fragment in location["fragments"]
                    ])
          for location in locations
          ])
      return ""
    def parse_group_column(values, selector):
      return ",".join([parse_column(value, selector) for value in values])
    
    def parse_column(value, selector):
      if value is None:
        return ""
      elif "member_databases" in selector:
        return parse_member_databases(value)
      elif "go_terms" in selector: 
        return parse_go_terms(value)
      elif "children" in selector: 
        return parse_items(value)
      elif "locations" in selector:
        return parse_locations(value)
      return str(value)
    
    def output_list():
      #disable SSL verification to avoid config issues
      context = ssl._create_unverified_context()
    
      next = BASE_URL
      last_page = False
    
      
      attempts = 0
      while next:
        try:
          req = request.Request(next, headers={"Accept": "application/json"})
          res = request.urlopen(req, context=context)
          # If the API times out due a long running query
          if res.status == 408:
            # wait just over a minute
            sleep(61)
            # then continue this loop with the same URL
            continue
          elif res.status == 204:
            #no data so leave loop
            break
          payload = json.loads(res.read().decode())
          next = payload["next"]
          attempts = 0
          if not next:
            last_page = True
        except HTTPError as e:
          if e.code == 408:
            sleep(61)
            continue
          else:
            # If there is a different HTTP error, it wil re-try 3 times before failing
            if attempts < 3:
              attempts += 1
              sleep(61)
              continue
            else:
              sys.stderr.write("LAST URL: " + next)
              raise e
    
        for i, item in enumerate(payload["results"]):
            if payload["results"]!="":
                #print(payload["results"], file=sys.stderr, end=" ")
                for j in range(0,len(item["residues"])):
                    if len(item["residues"][j]["roles"])!=0:
                        if len(item["residues"][j]["residue_sequences"])!=0:
                            sys.stdout.write(parse_column(item["residues"][j]["residue_sequences"][0]["uniprot_id"], 'uniprot_id') + "\t")
                            sys.stdout.write(parse_column(item["residues"][j]["residue_sequences"][0]["resid"], 'resid') + "\t")
                            sys.stdout.write("\n")
          
          # Don't overload the server, give it time before asking for more
        if next:
          sleep(1)
    
    if __name__ == "__main__":
      output_list()
      
